/* keypress values */
#define MVLEFT 1
#define MVRIGHT 2
#define MVUP 3		/* rotate */
#define MVDOWN 4	/* softdrop */
#define A_BTN 5		/* rotate clockwise */
#define B_BTN 6		/* rotate anticlockwise */
#define HARDDROP ' '
#define STARTBTN '\n'
#define ESC '\033'

/* keypress bit flags */
#define IN_GAME 0x100
#define PLAYER_1 0x200
#define PLAYER_2 0x400
#define SAFE_DROP 0x1000

#define SINGLE_PL 0x800

#ifndef TWOPLAYER
#  undef PLAYER_1
#  undef PLAYER_2
#  define PLAYER_1 0
#  define PLAYER_2 0
#endif

#define DAS_INITIAL_DELAY 266
#define DAS_DELAY 100

const char input_chr9[9][4];

#ifdef SOCKET
#  define socket_fd inputdevs_fd[3]
#  define NUM_INPUTDEVS 4
#else
#  define socket_fd -1
#  ifdef JOYSTICK
#    define NUM_INPUTDEVS 3
#  else
#    define NUM_INPUTDEVS 1
#  endif
#endif

int inputdevs_fd[4];
char inputdevs_player[4];
#ifdef JOYSTICK
char inputdevs_str[14];

int getinputdev(const char *key);
const char *getinputdev_str(int i);
#else
#define getinputdev(key) 0
#endif

void init_inputdevs();
#ifdef JOYSTICK
void close_inputdev(int i);
#endif

/* get time in milliseconds > tm */
int gettm(int tm);

/* wait us microseconds for input on fd */
int waitinput(int fd, unsigned us);

int getkeypress(int tm, int flags);
int getkeypress_block(int flags);

#ifdef JOYSTICK
int test_autorep_tm(short *tm);
#endif

int setkeymapping(int dev, int keypress);
const char *getkeyfor_str(int dev, int keypress);

/* processkey_ingame flags */
#define DISCARD_MOVES 1
#define DISCARD_DROPS 2
#define NO_PAUSE 8

int processkey_ingame(int keypress, int flags);

void input_cleanup();
