#ifdef TWOPLAYER
#define GAMEMENU_LENGTH 7
#else
#define GAMEMENU_LENGTH 10
#endif

typedef int (*menuhandler)(int keypress, int *pos);

#ifdef NO_MENU
#define static_ifnomenu static
#define in_menu 0
#else
#define static_ifnomenu

int in_menu;

void printmenuitem(const char *name, int sel);
void printmenuitem_options(const char *str, int sel);

void drawmenu(const char **menu, int n, int pos, int x, int y,
	      menuhandler *handlers);

int handle_menuitem(const char **menu, int n, int *i, int x, int y,
		    menuhandler *handlers, int keypr);

int handle_menuitem_2cols(const char **menu, int n, int *i, int h,
			  int x, int y, menuhandler *handlers, int keypr);

int dropdownlist(const char **items, int n, int i, int x, int y);
int selectitem(const char **items, int n, int *i, int keypress);

#ifdef TWOPLAYER
int startupmenu(int i, int x, int y);
#endif
#endif /* !NO_MENU */

void inputsetup_menu(int player, int x, int y);
#ifndef NO_MENU
void inputsetup_box(int player, int x, int y);

int gamemenu(int i, int x, int y);
void optionsmenu(const char **items, int n, menuhandler f, int x, int y);

void show_hiscorelist(int x, int y);
#endif
void show_hiscorelist5(int x, int y, int pos);
int gameovermenu();

/* menu_socket.c */
#if defined(SOCKET) && !defined(NO_MENU)
int select_2p_tty(int x, int y);
int menu_checkinvit(int x, int y);
int gamemenu_socket(const char **menu, int i, int x, int y,
		    menuhandler *handlers);
#endif
