struct option {
	union val {
		int integ;
		char str[4];
	} val;
	struct option *next;
	char tp_key[1];
};

#define opt_key(o) ((o)->tp_key+1)
#define opt_isint(o) ((o)->tp_key[0] == 0)
#define opt_isstr(o) ((o)->tp_key[0] == 1)

struct sect {
	char name[8];
	struct option *opts;
	struct sect *next;
} sect_hd;

/* returns 0 if converted to int, 1 if copied as string */
int strtoval(const char *str, union val *val);

struct sect *addsect(const char *name);
void addopt(const char *key, union val val, int tp, struct sect *sect);

struct option *getoptions(const char *sect_name);
int getopt_int(const char *sect_name, const char *key);
char *getopt_str(const char *sect_name, const char *key);

/* type should be 0 if val is int, 1 if string */
void setoption(const char *sect_name, const char *key, union val, int type);

void unsetoption(const char *sect_name, const char *key);
void freeoptions(const char *sect_name);
