#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#include <string.h>	/* strerror */
#include <errno.h>

#include "sock-priv.h"
#ifndef SOCKET
#define SOCKET
#endif
#ifndef INET
#define INET
#endif
#include "socket.h"

static struct in_addr *get_h_addr(const char *name)
{
	struct hostent *h = gethostbyname(name);
	if (!h) {
		printf("Unknown host %s\n", name);
		exit(1);
	}
	return (struct in_addr *) h->h_addr;
}

static void getaddr(const char *name, unsigned short port)
{
	struct sockaddr_in *addr;
	if (sockaddr)
		free(sockaddr);
	addr = malloc(sizeof(struct sockaddr_in));
	addr->sin_family = AF_INET;
	addr->sin_port = htons(port);
	if (name)
		addr->sin_addr = *get_h_addr(name);
	else
		addr->sin_addr.s_addr = htonl(INADDR_ANY);
	sockaddr = (struct sockaddr *) addr;
}

void mksocket_inet(const char *name, unsigned port)
{
	char *msg = mksocket(PF_INET);
	if (msg)
		goto err;
	getaddr(name, port);
	if (!name) {
		msg = bind_listen(sizeof(struct sockaddr_in));
		if (msg)
			goto err;
		printf("Listening for connections on port %d...\n", port);
		return;
	}
	printf("Connecting to %s on port %u...\n", name, port);
	if (connectsock(sizeof(struct sockaddr_in)))
		return;
	printf("FAILED! %s\n", strerror(errno));
	exit(1);

err:	printf("%s\n", msg);
	free(msg);
	exit(1);
}
