#include <stdlib.h>
#include <string.h>
#ifdef NO_MENU
#undef NO_MENU
#endif
#ifndef TWOPLAYER
#define TWOPLAYER
#endif
#ifndef SOCKET
#define SOCKET
#endif
#include "menu.h"
#include "input.h"
#include "socket.h"
#include "term.h"
#include "draw.h"
#include "tetris.h"

static int yesno_menu(int x, int y)
{
	const char *menu[2] = {"Yes", "No"};
	int i = 0;
	int xx;
	while (1) {
		setcurs(x, y);
		printmenuitem("Yes", !i);
		printmenuitem("No", i);
		xx = i ? x+6 : x;
		setcurs(xx, y);
		refreshwin(-1);
		switch (handle_menuitem_2cols(menu, 2, &i, 1, xx, y, NULL,
					      getkeypress_block(SINGLE_PL))) {
		case 0:
			return 0;
		case 2:
			return !i;
		}
	}
}

static int invit_dialog(const char *user, const char *tty, int x, int y)
{
	char word[7];
	const char *p = "wants to battle you. ";
	const char *q;
	int i, n;
	drawbox(x, y, 32, 7, "2P GAME INVITATION");
	setcurs(x+2, y+2);
	printstr(user);
	printstr(" on ");
	printstr(tty);
	i = strlen(user) + strlen(tty) + 4;
	while (*p) {
		q = strchr(p, ' ');
		n = q-p;
		if (i+n > 27) {
			newln(x+2);
			i = 0;
		} else {
			putch(' ');
			i++;
		}
		strncpy(word, p, n);
		word[n] = '\0';
		printstr(word);
		i += n;
		p = q+1;
	}
	setcurs(x+11, y+5);
	printstr("Accept?  ");
	i = yesno_menu(x+20, y+5);
	clearbox(x, y, 32, 7);
	return i;
}

int select_2p_tty(int x, int y)
{
	const char *items[4] = {"this terminal"};
	char ttys[3][8];
	char *msg;
	int i;
	if (!get_2p_ttys(ttys[0], 3))
		return 1;
	for (i = 0; i < 3 && *ttys[i]; i++)
		items[i+1] = ttys[i];
	i = dropdownlist(items, i+1, 0, x, y);
	if (!i)
		return 0;
	if (i > 1 && (msg = mksocket_local(ttys[i-2], 1))) {
		setcurs_end();
		printstr(msg);
		free(msg);
		return 0;
	}
	return 1;
}

int menu_checkinvit(int x, int y)
{
	const struct invit *inv = invit;
	char *msg;
	if (inv) {
		invit = NULL;
		if (invit_dialog(inv->user, inv->tty, x, y)) {
			msg = mksocket_local(inv->tty, 0);
			if (!msg)
				return 2;
			setcurs_end();
			printstr(msg);
			free(msg);
		}
		return -1;
	}
	return 0;
}

int gamemenu_socket(const char **menu, int i, int x, int y, menuhandler *hs)
{
	int keypr;
	/* remove separator */
	memmove(menu+2, menu+3, 3*sizeof(*menu));
	memmove(hs+2, hs+3, 3*sizeof(*hs));
	if (i>2)
		i--;
	drawmenu(menu, 5, i, x, y, hs);
	while (1) {
		setcurs(x, y+5);
		newln(x);
		if (!(sock_flags & CONNECTED))
			printstr("Waiting for opponent...");
		else {
			sock_sendplayer();
			sock_sendbyte('h'); /* request height */
			sock_sendbyte('-');

			setattr_bold();
			printstr("PLAYER 2");
			cleartoeol();
			setattr_normal();
			newln(x+4);
			printstr("Level:  ");
			putch(player2.startlevel+'0');
			movefwd(4);
			printstr("Height:  ");
			putch(player2.height+'0');
		}
		newln(x);
		setcurs(x, y+i);
		refreshwin(-1);
		keypr = getkeypress(1000, 0);
		if (!keypr)
			continue;
		switch (handle_menuitem(menu, 5, &i, x, y+i, hs, keypr)) {
		case 0:
			clearbox(0, y+7, 0, 1);
			return 0;
		case 2:
			player2.height = 0;
			if (i>1)
				i++;
			return i+1;
		}
	}
}
